unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, StdCtrls, CPort, ExtCtrls;

type
  TfrmMain = class(TForm)
    ComPort: TComPort;
    Label1: TLabel;
    cbbox_Port: TComboBox;
    Label2: TLabel;
    cbbox_BaudRate: TComboBox;
    btConnect: TButton;
    Label3: TLabel;
    mem_InformationWnd: TMemo;
    bt_Clear: TBitBtn;
    cbbox_Adr: TComboBox;
    edt_SettingCmd: TEdit;
    bt_Send: TBitBtn;
    bt_Read: TBitBtn;
    Bevel1: TBevel;
    Label4: TLabel;
    Bevel2: TBevel;
    Label6: TLabel;
    cbbox_OPM_Adr: TComboBox;
    btOPM_Reset: TBitBtn;
    Bevel3: TBevel;
    Label7: TLabel;
    Label9: TLabel;
    edt_OPM_Volt: TEdit;
    btOPM_VoltSet: TBitBtn;
    btOPM_OutON: TBitBtn;
    btOPM_OutOFF: TBitBtn;
    edt_OPM_Curr: TEdit;
    btOPM_CurrSet: TBitBtn;
    edt_OPM_MeasV: TEdit;
    btOPM_VoltMeas_Send: TBitBtn;
    btOPM_VoltMeas_Read: TBitBtn;
    btOPM_CurrMeas_Send: TBitBtn;
    btOPM_CurrMeas_Read: TBitBtn;
    edt_OPM_MeasA: TEdit;
    edt_OPM_FloatV: TEdit;
    Label5: TLabel;
    Label8: TLabel;
    edt_OPM_FloatA: TEdit;
    Label10: TLabel;
    Label11: TLabel;
    cbbox_OPM_Adr_Finish: TComboBox;
    edt_OPM_Volt_Start: TEdit;
    Label12: TLabel;
    Label13: TLabel;
    edt_OPM_Volt_Finish: TEdit;
    Label14: TLabel;
    edt_OPM_Cycle_Delay: TEdit;
    Label15: TLabel;
    Label16: TLabel;
    edt_OPM_Cycle_Repeat: TEdit;
    btOPM_Cycle_Start: TBitBtn;
    cbbox_OPM_Adr_Start: TComboBox;
    memCycling: TMemo;
    BitBtn1: TBitBtn;
    Bevel4: TBevel;
    Label17: TLabel;
    Label18: TLabel;
    edt_OPM_Volt_Step: TEdit;
    procedure cbbox_PortChange(Sender: TObject);
    procedure cbbox_BaudRateChange(Sender: TObject);
    procedure btConnectClick(Sender: TObject);
    procedure bt_ClearClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure bt_SendClick(Sender: TObject);
    procedure bt_ReadClick(Sender: TObject);
    procedure ComPortRxChar(Sender: TObject; Count: Integer);
    procedure btOPM_ResetClick(Sender: TObject);
    procedure btOPM_VoltSetClick(Sender: TObject);
    procedure btOPM_OutONClick(Sender: TObject);
    procedure btOPM_OutOFFClick(Sender: TObject);
    procedure btOPM_CurrSetClick(Sender: TObject);
    procedure btOPM_VoltMeas_SendClick(Sender: TObject);
    procedure btOPM_VoltMeas_ReadClick(Sender: TObject);
    procedure btOPM_CurrMeas_SendClick(Sender: TObject);
    procedure btOPM_CurrMeas_ReadClick(Sender: TObject);
    procedure btOPM_Cycle_StartClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private declarations }
  public
    str_RXBuffer: String;
    str_TXBuffer: String;
    str_RXBackBuf: String;
    bol_rev: boolean; // ϷǸ  true
                      //̼ſϷ ¸ false
    bol_manual: boolean; //False  Auto(send & Read mode)
                         //True  Readư  infomation Window ȿö
  end;

var
  frmMain: TfrmMain;

implementation
uses Registry,TypInfo,ShellAPI;

{$R *.DFM}

//Com Port Setting
procedure TfrmMain.cbbox_PortChange(Sender: TObject);
begin
  ComPort.Port:= cbbox_Port.Text;
end;

//Baud Rate Setting
procedure TfrmMain.cbbox_BaudRateChange(Sender: TObject);
begin
  SetEnumProp(ComPort,'BaudRate',cbbox_BaudRate.Text);
end;

//RS232C Connection
procedure TfrmMain.btConnectClick(Sender: TObject);
begin
  if btConnect.Caption = 'Connect' then
  begin   // Com Port Close¶  Port OpenѴ.
    try
      ComPort.Open;
      btConnect.Caption:= 'DisConnect';
      cbbox_Port.Enabled:= False;
      cbbox_BaudRate.Enabled:= False;
      bt_ClearClick(nil);
    except   //ٸ ̰ų  Ʈ Erroró
      MessageDlg('You Can`t open ' + cbbox_Port.Text +'.'
          + #13 + cbbox_Port.Text + ' is already opened or You should exchange setting!',mtError,[mbOk],0);
    end;
  end
  else
  begin     //ִ Port CloseѴ.
    ComPort.Close;
    btConnect.Caption:= 'Connect';
    cbbox_Port.Enabled:= True;
    cbbox_BaudRate.Enabled:= True;
  end
end;

//EX-SeriesMemo Clear
procedure TfrmMain.bt_ClearClick(Sender: TObject);
begin
  mem_InformationWnd.Clear;
end;

procedure TfrmMain.FormActivate(Sender: TObject);
begin
  str_RXBackBuf:= '';
  str_RXBuffer:= '';
  str_TXBuffer:= '';
  ComPort.Port:= 'COM4';
  cbbox_Port.Text:= 'COM4';
  cbbox_BaudRate.Text:= 'br115200';
  SetEnumProp(ComPort,'BaudRate',cbbox_BaudRate.Text);
end;

//Ex-Series Command Send
procedure TfrmMain.bt_SendClick(Sender: TObject);
begin
  if ComPort.Connected = False then
  begin
    MessageDlg('Comm Port hasn''t been initialized!',mtWarning,[mbOk],0);
    exit;
  end;
  str_RXBuffer:= '';
  str_RXBackBuf:= '';
  bol_rev:= False;
  bol_manual:= True;
  ComPort.WriteStr('ODA'+ chr(StrToInt(cbbox_Adr.Text))+edt_SettingCmd.text+#10);
end;

//Ex-Series Data Read
procedure TfrmMain.bt_ReadClick(Sender: TObject);
begin
  if bol_rev then
  begin
    mem_InformationWnd.Lines.Add(str_RXBackBuf);
    str_RXBackBuf:= '';
    bol_rev:= False;
  end
end;

procedure TfrmMain.ComPortRxChar(Sender: TObject; Count: Integer);
var str,strTemp: String;
begin
  ComPort.ReadStr(str,count);
  // LFṮ
  if str[count] = #10 then
  begin
    bt_Send.Enabled:= True;
    bt_Read.Enabled:= True;

    bol_rev:= True;
    // Send & Read¶ ӽ ۿ ͸ ϰ ִ´.
    str_RXBackBuf:= str_RXBackBuf + (str_RXBuffer+str);
    str_RXBuffer := '';
  end
  else str_RXBuffer := str_RXBuffer + str;
end;

//OPM-Series Reset Command Send
procedure TfrmMain.btOPM_ResetClick(Sender: TObject);
begin
 if ComPort.Connected = False then
  begin
    MessageDlg('Comm Port hasn''t been initialized!',mtWarning,[mbOk],0);
    exit;
  end;
  // ǰ Reset Ͽ ʱȭ Ѵ.
  ComPort.WriteStr('ODA'+ chr(StrToInt(cbbox_OPM_Adr.Text))+chr(0)+'R'+#10);
end;

//OPM-Series Output-ON Command Send
procedure TfrmMain.btOPM_OutONClick(Sender: TObject);
begin
 if ComPort.Connected = False then
  begin
    MessageDlg('Comm Port hasn''t been initialized!',mtWarning,[mbOk],0);
    exit;
  end;
  // Power Supply  ONѴ.
  ComPort.WriteStr('ODA'+ chr(StrToInt(cbbox_OPM_Adr.Text))+chr(1)+'O'+chr(1)+#10);
end;

//OPM-Series Output-OFF Command Send
procedure TfrmMain.btOPM_OutOFFClick(Sender: TObject);
begin
 if ComPort.Connected = False then
  begin
    MessageDlg('Comm Port hasn''t been initialized!',mtWarning,[mbOk],0);
    exit;
  end;
  // Power Supply  OFFѴ.
  ComPort.WriteStr('ODA'+ chr(StrToInt(cbbox_OPM_Adr.Text))+chr(1)+'O'+chr(0)+#10);
end;

//OPM-Series Voltage Setting Command Send
procedure TfrmMain.btOPM_VoltSetClick(Sender: TObject);
var realVolt:real;
  tmp,fload_count:Word;  //2byte
  intVolt_High,intVolt_Low:byte;
begin
 if ComPort.Connected = False then
  begin
    MessageDlg('Comm Port hasn''t been initialized!',mtWarning,[mbOk],0);
    exit;
  end;
  //Power Supply ҼƷ Digit ִ  Ѵ.
  // 30Vǰ 30.000̹Ƿ 3...
  //100Vǰ 100.00 ̹Ƿ 2 Էؾ Ѵ.
  if edt_OPM_FloatV.Text = '2' then fload_count := 100
  else if edt_OPM_FloatV.Text = '3' then fload_count := 1000
  else if edt_OPM_FloatV.Text = '4' then fload_count := 10000
  else
  begin
    MessageDlg(' Ҽ ڸ 2,3,4 ߿ Էؾ մϴ.',mtError,[mbOk],0);
    exit;
  end;
  realVolt:= StrToFloat(edt_OPM_Volt.Text)*fload_count;  //Ҽ 
  tmp:= TRUNC(realVolt);   //Ҽ   ȯ(TRUNC)
  intVolt_High:= tmp shr 8; //2byte   и
  intVolt_Low:= tmp;
  // øɰ Է  , Power Supply Ѵ.
  ComPort.WriteStr('ODA'+ chr(StrToInt(cbbox_OPM_Adr.Text))+chr(2)+'V'+chr(intVolt_High)+chr(intVolt_Low)+#10);
end;

//OPM-Series Current Setting Command Send
procedure TfrmMain.btOPM_CurrSetClick(Sender: TObject);
var realCurr:real;
  tmp,fload_count:Word;  //2byte
  intCurr_High,intCurr_Low:byte;
begin
 if ComPort.Connected = False then
  begin
    MessageDlg('Comm Port hasn''t been initialized!',mtWarning,[mbOk],0);
    exit;
  end;

  if edt_OPM_FloatA.Text = '2' then fload_count := 100
  else if edt_OPM_FloatA.Text = '3' then fload_count := 1000
  else if edt_OPM_FloatA.Text = '4' then fload_count := 10000
  else
  begin
    MessageDlg(' Ҽ ڸ 2,3,4 ߿ Էؾ մϴ.',mtError,[mbOk],0);
    exit;
  end;
  realCurr:= StrToFloat(edt_OPM_Curr.Text)*fload_count;
  tmp:= TRUNC(realCurr);
  intCurr_High:= tmp shr 8;
  intCurr_Low:= tmp;
  ComPort.WriteStr('ODA'+ chr(StrToInt(cbbox_OPM_Adr.Text))+chr(2)+'W'+chr(intCurr_High)+chr(intCurr_Low)+#10);
end;


//OPM-Series Voltage Measurement Command Send
procedure TfrmMain.btOPM_VoltMeas_SendClick(Sender: TObject);
begin
 if ComPort.Connected = False then
  begin
    MessageDlg('Comm Port hasn''t been initialized!',mtWarning,[mbOk],0);
    exit;
  end;
  str_RXBuffer:= '';
  str_RXBackBuf:= '';
  bol_rev:= False;
  bol_manual:= True;
  // µǴ   Ѵ.
  ComPort.WriteStr('ODA'+ chr(StrToInt(cbbox_OPM_Adr.Text))+chr(0)+'T'+#10);
end;

//OPM-Series Voltage Measurement data read
procedure TfrmMain.btOPM_VoltMeas_ReadClick(Sender: TObject);
var intVolt_High,intVolt_Low:byte;
    intVolt,fload_count:Word;
    intVoltReal:Real;
begin
  if bol_rev then
  begin
    //Power Supply Ҽ ġ ľѴ.
    if edt_OPM_FloatV.Text = '2' then fload_count := 100
    else if edt_OPM_FloatV.Text = '3' then fload_count := 1000
    else if edt_OPM_FloatV.Text = '4' then fload_count := 10000
    else
    begin
      MessageDlg(' Ҽ ڸ 2,3,4 ߿ Էؾ մϴ.',mtError,[mbOk],0);
      exit;
    end;

    intVolt_High:= ord(str_RXBackBuf[3]); //,   2byte ԷѴ.
    intVolt_Low:= ord(str_RXBackBuf[4]);
    intVolt:= (intVolt_High shl 8) or intVolt_Low;
    intVoltReal:= intVolt;
    intVoltReal:= intVoltReal / fload_count;   // Ҽ ġ ؼ ش.
    edt_OPM_MeasV.Text:= FloatToStr(intVoltReal);
    memCycling.Lines.Add(FloatToStr(intVoltReal));
    str_RXBackBuf:= '';
    bol_rev:= False;
  end
end;

//OPM-Series Current Measurement Command Send
procedure TfrmMain.btOPM_CurrMeas_SendClick(Sender: TObject);
begin
 if ComPort.Connected = False then
  begin
    MessageDlg('Comm Port hasn''t been initialized!',mtWarning,[mbOk],0);
    exit;
  end;
  str_RXBuffer:= '';
  str_RXBackBuf:= '';
  bol_rev:= False;
  bol_manual:= True;
  ComPort.WriteStr('ODA'+ chr(StrToInt(cbbox_OPM_Adr.Text))+chr(0)+'U'+#10);
end;

//OPM-Series Current Measurement data read
procedure TfrmMain.btOPM_CurrMeas_ReadClick(Sender: TObject);
var intCurr_High,intCurr_Low:byte;
    intCurr,fload_count:Word;
    intCurrReal:Real;
begin
  if bol_rev then
  begin
    if edt_OPM_FloatA.Text = '2' then fload_count := 100
    else if edt_OPM_FloatA.Text = '3' then fload_count := 1000
    else if edt_OPM_FloatA.Text = '4' then fload_count := 10000
    else
    begin
      MessageDlg(' Ҽ ڸ 2,3,4 ߿ Էؾ մϴ.',mtError,[mbOk],0);
      exit;
    end;

    intCurr_High:= ord(str_RXBackBuf[3]);
    intCurr_Low:= ord(str_RXBackBuf[4]);
    intCurr:= (intCurr_High shl 8) or intCurr_Low;
    intCurrReal:= intCurr;
    intCurrReal:= intCurrReal / 10000;
    edt_OPM_MeasA.Text:= FloatToStr(intCurrReal);
    memCycling.Lines.Add(FloatToStr(intCurrReal));
    str_RXBackBuf:= '';
    bol_rev:= False;
  end
end;

procedure TfrmMain.btOPM_Cycle_StartClick(Sender: TObject);
var int_Start_Adr,int_Finish_Adr:byte;
    Real_Send_Volt,Real_Start_Volt,Real_Finish_Volt, Real_Step_Volt:Real;
    i,j,int_repeat,int_delay:Integer;
    error_chk:Integer;
begin
  // Power Supply  а Cycling Test ϴ Լ
  int_Start_Adr:= StrToInt(cbbox_OPM_Adr_Start.Text);
  int_Finish_Adr:= StrToInt(cbbox_OPM_Adr_Finish.Text);
  Real_Start_Volt:= StrToFloat(edt_OPM_Volt_Start.Text);
  Real_Finish_Volt:= StrToFloat(edt_OPM_Volt_Finish.Text);
  int_repeat:= StrToInt(edt_OPM_Cycle_Repeat.Text);
  Real_Step_Volt:= StrToInt(edt_OPM_Volt_Step.Text);
  int_delay:= StrToInt(edt_OPM_Cycle_Delay.Text);
 if ComPort.Connected = False then
  begin
    MessageDlg('Comm Port hasn''t been initialized!',mtWarning,[mbOk],0);
    exit;
  end;
  for i:= 0 to int_repeat-1 do  //ü ݺȽ
  begin
    cbbox_OPM_Adr.Text:= '255'; //ü ä (۽ Ŀ常 )
    btOPM_ResetClick(Nil); //Reset
    Sleep(100);
    btOPM_OutONClick(Nil);
    Sleep(int_delay);
    Real_Send_Volt:= Real_Start_Volt;
    while Real_Send_Volt <= Real_Finish_Volt do // 
    begin
      edt_OPM_Volt.Text:= FloatToStr(Real_Send_Volt); // Voltage Է
      Real_Send_Volt:= Real_Send_Volt + Real_Step_Volt;
      for j:=int_Start_Adr to int_Finish_Adr do
      begin
        cbbox_OPM_Adr.Text:= IntToStr(j);
        btOPM_VoltSetClick(Nil);  // 
        Sleep(int_delay); //  Delay
//        btOPM_VoltMeas_SendClick(Nil);
//        Sleep(int_delay); //  Delay
//        btOPM_VoltMeas_ReadClick(Nil);
        memCycling.Lines.Add('ADR = ' + cbbox_OPM_Adr.Text + '  V = '+ edt_OPM_Volt.Text);
      end;
    end;

  end;
end;

procedure TfrmMain.BitBtn1Click(Sender: TObject);
begin
  memCycling.Clear;
end;

end.
